#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <sys/timeb.h>
#include <time.h>

#include <sched.h>
#include "MNetHttp.h"
#include "MNetUtil.h"

#include "msgtypes.h"

//////////////////////////
// advanced options

// defines the maximum number of players
const unsigned int MAXPLAYER=64;

// if this value is set to true, the maps and the multiplier get randomly choosen.
const bool randomize=false;


////////////////////////////////////////////////////////////////////////////
// don't change things from here on unless you know what you are doing ...

// 0.7.0: 2005-12-30
// 0.8.0: 2010-04-28
const char version[]="0.8.0"; 
const char walkoverversion[]="1.1.0";


const unsigned int SENDFLAGS = MSG_NOSIGNAL|MSG_DONTWAIT;
const unsigned int RECVFLAGS = MSG_NOSIGNAL|MSG_DONTWAIT;


const char logfilename[]="log";
char lt[1024];
void Log(char *t)
{
	FILE *f=fopen(logfilename,"at+");
	time_t timet;
	timet=time(0);
	tm *ltm=localtime(&timet);
	fprintf(f,"%04u/%02u/%02u %02u:%02u:%02u\t%s\n",1900+ltm->tm_year,ltm->tm_mon+1,ltm->tm_mday,ltm->tm_hour,ltm->tm_min,ltm->tm_sec,t);
	fclose(f);
}


class WServerClient
{
public:	
	bool playing;
	unsigned int playid;
	int phase;
	unsigned int localid;
	bool ready;
	char *playername;
	bool admin;
	char * recvbuf;
	unsigned int recvused,recvdone;
	unsigned int id;
	unsigned int sock;
	sockaddr_in addr;
	WServerClient() 
	{
		//int i;

		recvbuf=new char[128*1024];
			
		recvused=0;
		recvdone=0;

		admin=false;
		playername=new char[256];

		playing=false;	
	}
	~WServerClient() 
	{
		delete [] recvbuf;

		delete [] playername;
	}
};

typedef WServerClient *LPWServerClient;
LPWServerClient csocket[MAXPLAYER];
unsigned int csocketn;
unsigned int socklisten;
timeval timeout_directly;
sockaddr_in addr;

unsigned int stillplaying;
unsigned int playn;
bool dedicated;
unsigned int enemylimit;
unsigned int enemylimitlimit;
int mode;
short int inputstate[4*MAXPLAYER];
unsigned int hard;
unsigned int phase;
char mapname[256];

void Init();
void MainLoop();
unsigned int SendSave(unsigned int id, unsigned int msgtype, char *p, unsigned int len);
void RecvSave(unsigned int id, char *p, unsigned int len);
void SendCurrentStateAll();
void SendToAll(unsigned int msgtype, char *p, unsigned int len);
void SetRandomMap();
void UpdateEnemyMultiplier();

bool fileexists(char *filename)
{
	FILE *f=fopen(filename,"rb");
	if (f==0)
		return false;
	else
	{
		fclose(f);
		return true;
	}
}

inline unsigned long long GetTime()
{
	timeb tp;
	ftime(&tp);
	unsigned long long t=(tp.time*1000)+(tp.millitm);
	return t;
}

inline unsigned long long GetTimeSec()
{
	timeb tp;
	ftime(&tp);
	return tp.time;
}



static unsigned long long criticaltime_t;
inline void criticaltimestart()
{
	criticaltime_t=GetTime();
}
inline void criticaltimeend(const char * name)
{
	unsigned long long now=GetTime();
	unsigned long long d=now-criticaltime_t;
	if (d>=1000) // warn for everyting that takes longer than 1sec
	{
		sprintf(lt,"CriticalTime Warning %llums: %s (%llu, %llu)",d,name,now,criticaltime_t);
		Log(lt);
	}		
}


// Update Online-List Code ////////////////////////////////////////////////
bool updateonlinestatus=true;
unsigned long long updateonlinestatuslast=0;
char ListHostIP[256];
char ListHostFile[256];
unsigned int ListHostIPUI;
unsigned int LocalPort;
char LocalIP[256];
unsigned int LocalIPUI;
char PublicIP[256];
char ServerName[256];
char ListHostName[256];
unsigned long long Started=0;
int UpdateOnlineStatus()
{
	char t[1024*16];
	sprintf(t,"%s?name=D-%s&ip=%s:%u&started=%llu&player=%u&version=%s&serverversion=%s",ListHostFile,ServerName,PublicIP,LocalPort,Started,csocketn,walkoverversion,version);
	
	int tlen=1024*16-1;
	MNetHttpGet(ListHostName,ListHostIPUI,80,t,t,&tlen);
	t[tlen]=0;
	
	if (t[0]=='0')
		return 0;
	else
		return 1;
}
int thread2(void *)
{
	while (true)
	{
		if (updateonlinestatus)
		{
			updateonlinestatus=false;
			UpdateOnlineStatus();
			updateonlinestatuslast=GetTime();
		}
		
		if (GetTime()-updateonlinestatuslast>5*60*1000)
			updateonlinestatus=true;
		
		usleep(1000000);
	}
}
///////////////////////////////////////////////////////////////77

void Init()
{
	Log("start of initialization");

	Started=GetTimeSec();
	
	unsigned int i;
	//sendbuf=new char[128*1024];
	//for (i=0;i<128*1024;i++)
	//	sendbuf[i]=0;
	
	srand(time(0));
	
	csocketn=0;
	for (i=0;i<MAXPLAYER;i++)
	{
		csocket[i]=new WServerClient();
		csocket[i]->id=i;
		csocket[i]->ready=false;
	}
	
	mapname[0]=0;
	hard=1;
	mode=0;
	enemylimit=1000;
	enemylimitlimit=enemylimit;
	phase=0;
	
	// parsing config file
	printf("Parsing config file:\n");
	Log("Parsing config file:");
	char param[256];
	char *value;
	FILE *f=fopen("server.cfg","rt");
	while (!feof(f))
	{
		param[0]=0;
		fscanf(f,"%s",param);
		value=strstr(param,"=");
		if (value==0)
			continue;
		*value=0;
		value++;
		
		sprintf(lt,"%s=%s",param,value);
		Log(lt);
		printf(lt);
		printf("\n");
		
		if (strcmp(param,"localip")==0)
		{
			strcpy(LocalIP,value);
			LocalIPUI=MNetIP(LocalIP);
		}
		else
		if (strcmp(param,"localport")==0)
		{
			sscanf(value,"%u",&LocalPort);
		}
		else
		if (strcmp(param,"publicip")==0)
		{
			strcpy(PublicIP,value);
		}
		else
		if (strcmp(param,"servername")==0)
		{
			strcpy(ServerName,value);
		}
		else
		if (strcmp(param,"dedicated")==0)
		{
			if (value[0]=='0')
				dedicated=false;
			else
				dedicated=true;
		}
		else
		if (strcmp(param,"listhostip")==0)
		{
			strcpy(ListHostIP,value);
			ListHostIPUI=MNetIP(ListHostIP);
		}
		else
		if (strcmp(param,"listhostname")==0)
		{
			strcpy(ListHostName,value);
		}
		else
		if (strcmp(param,"listhostfile")==0)
		{
			strcpy(ListHostFile,value);
		}
		else
		if (strcmp(param,"enemylimitlimit")==0)
		{
			sscanf(value,"%u",&enemylimitlimit);
		}
	}
	
	if (dedicated)
		SetRandomMap();
	
	// listensocket initialization
	socklisten=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
	
	memset(&addr,0,sizeof(sockaddr_in));

	addr.sin_family=AF_INET;
	addr.sin_port=htons(LocalPort);
	addr.sin_addr.s_addr=LocalIPUI;
	
	sprintf(lt,"binding to %s %u",LocalIP,LocalPort);
	Log(lt);
	
	if (0!=bind(socklisten,(sockaddr*)&addr,sizeof(sockaddr_in)))
	{
		sprintf(lt,"unable to bind socket; check the ip in server.txt");
		Log(lt);
		exit(1);
	}
	
	if (0!=listen(socklisten,5))
	{
		sprintf(lt,"unable to listen");
		Log(lt);
		exit(2);
	}

	bool b=true;
	if (0!=setsockopt(socklisten,IPPROTO_TCP,TCP_NODELAY,(char*)&b,4))
	{
		Log("unable to set socketopt");
		exit(3);
	}

	timeout_directly.tv_sec=0;
	timeout_directly.tv_usec=0;
	
	void *childstack=((char*)malloc(128*1024))+128*1024-4;
	clone(thread2,childstack,CLONE_VM,0);
	
	Log("initialization successfull");
	printf("initialization successfull\n");
}

inline void HandleSockets()
{
	int ret;
	fd_set setread,setwrite,seterror;
	FD_ZERO(&setread);
	FD_ZERO(&setwrite);
	FD_ZERO(&seterror);

	// handle new connects
	FD_SET(socklisten,&setread);

	criticaltimestart();
	ret=select(socklisten+1,&setread,&setwrite,&seterror,&timeout_directly);
	criticaltimeend("handle new connects");
	if (1==ret)
	{
		if (csocketn<MAXPLAYER)
		{
			criticaltimestart();
			sprintf(lt,"player joined => %u",csocketn+1);
			Log(lt);
			
			WServerClient *newclient=csocket[csocketn];
			// *** accept erstellt selber einen socket !!!
			//newclient->sock=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
			
			socklen_t addrlen;
			addrlen=sizeof(sockaddr_in);
			newclient->sock=accept(socklisten,(sockaddr*)&newclient->addr,&addrlen);
			newclient->phase=0;
			csocketn++;

			bool b=true;
			if (0!=setsockopt(newclient->sock,IPPROTO_TCP,TCP_NODELAY,(char*)&b,4))
			{
				sprintf(lt,"unable to set TCP_NODELAY on new client socket");
				Log(lt);
				//exit(1);
			}
			criticaltimeend("player joined");
		}
		else
		{
			// Reject
			criticaltimestart();

			sprintf(lt,"reject player start");
			Log(lt);

			unsigned int sock=socket(AF_INET,SOCK_STREAM,IPPROTO_TCP);
			
			socklen_t addrlen;
			addrlen=sizeof(sockaddr_in);
			sockaddr_in addr;
			sock=accept(socklisten,(sockaddr*)&addr,&addrlen);
			
			close(sock);

			sprintf(lt,"reject player done");
			Log(lt);
			
			criticaltimeend("reject player");	
		}
	}


	// handle client-sockets
	WServerClient *client;
	unsigned int i;
	for (i=0;i<csocketn;i++)
	{
		client=csocket[i];
		
		criticaltimestart();
		FD_ZERO(&setread);
		FD_SET(client->sock,&setread);
		ret=select(client->sock+1,&setread,&setwrite,&seterror,&timeout_directly);
		criticaltimeend("handle client socket");

		if (ret==1)
		{
			criticaltimestart();
			ret=recv(client->sock,(char*)client->recvbuf+client->recvused,0x7000,RECVFLAGS);
			criticaltimeend("handle client socket / recv");
			if (ret<=0)
			{
				sprintf(lt,"player %s left => %u",client->playername,csocketn-1);
				Log(lt);
				
				// disconnect
				if (client->admin && (!dedicated))
				{
					sprintf(lt,"exit because admin-client disconnected and server is not dedicated");
					Log(lt);
					exit(0);
				}
				else
				{
					criticaltimestart();
		
					sprintf(lt,"%s disconnected",client->playername);
					Log(lt);

					unsigned int j;
					for (j=i;j<csocketn-1;j++)
					{
						csocket[j]=csocket[j+1];
						csocket[j]->id=j;
					}
					csocketn--;
					csocket[csocketn]=new WServerClient();
					csocket[csocketn]->id=csocketn;
					csocket[csocketn]->ready=false;
	
					SendCurrentStateAll();

					if (client->playing)
					{
						stillplaying--;
					}

					sprintf(lt,"%s disconnected 2",client->playername);
					Log(lt);

					close(client->sock);
					delete client;

					sprintf(lt,"disconnected 3");
					Log(lt);

					criticaltimeend("handle client socket / disconnect");
				}
			}
			else
			{
				criticaltimestart();
	
				client->recvused+=ret;
				
				unsigned int aktulen;
				while (client->recvdone+4<client->recvused)
				{
					aktulen=((unsigned int*)(client->recvbuf+client->recvdone))[0];
					if (client->recvdone+4+aktulen<=client->recvused)
					{
						client->recvdone+=4;
						RecvSave(i,client->recvbuf+client->recvdone,aktulen);
						client->recvdone+=aktulen;
					}
					else
						break;
				}
				if (client->recvused>=128*1024)
					Log("Mem Alert");
				if (client->recvdone==client->recvused)
				{
					client->recvdone=0;
					client->recvused=0;
				}

				criticaltimeend("handle client socket / process");
			}
		}
	}	
}

inline void HandlePhase()
{
	if (phase==0)
	{
		if ((csocketn>0) && (mapname[0]!=0))
		{
			unsigned int i;
			bool start=true;
			for (i=0;i<csocketn;i++)
				if (!csocket[i]->ready)
				{
					start=false;
					break;
				}	
	
			if (start)
			{	
				// Startgame
				Log("start game and wait for other players to finish loading");
				
				phase=1;
				
				for (i=0;i<4*MAXPLAYER;i++)
					inputstate[i]=0;

				SendToAll(MSG_STARTGAME,0,0);
			}
		}
	}
	else
	if (phase==1)
	{
		// warten auf alle spieler

		// Achtung, alles negiert!!!
		unsigned int i;
		bool start=false;
		for (i=0;i<csocketn;i++)
			if (csocket[i]->ready)
			{
				start=true;
				break;
			}

		if (!start)
		{
			// Starten
			Log("start gametime");
			
			phase=2;

			//playid setzen
			unsigned int i;
			for (i=0;i<csocketn;i++)
			{
				csocket[i]->playid=i;
				csocket[i]->playing=true;
			}			
			playn=csocketn;
			stillplaying=csocketn;

			SendToAll(MSG_STARTGAME2,0,0);
		}
	}
	else
	if (phase==2)
	{
		// eigentliches game
		//Sleep(rand()*50/RAND_MAX);

		SendToAll(MSG_TIMER,(char*)inputstate,playn*8);
		unsigned int i;
		// *** loop bis playn anstatt csocketn   fixed in windowsserver
		for (i=0;i<playn;i++)
			inputstate[i*4+2]&=0xff;  // cmds zurcksetzen
		// ***
		
		if (dedicated)
			if (stillplaying==0)
			{
				Log("game finished");
				phase=0;
				SetRandomMap();
			}	
	}

	static bool wasused=false;
	if (csocketn>0)
	{
		wasused=true;
	}
	if ((csocketn==0) && (wasused))
	{
		if (dedicated)
		{
			Log("empty server");
			wasused=false;
			phase=0;
			SetRandomMap();
		}
		else
		{
			Log("exit because not dedicated and 0 clients connected");
			exit(0);
		}
	}
}

void MainLoop()
{
	unsigned long long time0,time1;
	time0=GetTime();
	while (true)
	{
		usleep(1);
		
		HandleSockets();
		
		time1=GetTime();
		if (time1-time0>=32)
		{
			time0=time1;
			HandlePhase();
		}
	}
		
}

void RecvSave(unsigned int id, char *p, unsigned int len)
{
	WServerClient *client=csocket[id];

	unsigned int msgtype=((unsigned int *)p)[0];
	p+=4;
	len-=4;


	if (msgtype==MSG_CONNECTASADMINPLAYER)
	{
		client->admin=true;
		client->localid=((unsigned int*)p)[0];
		memcpy(client->playername,p+4,256);
		client->phase=1;
		
		UpdateEnemyMultiplier();

		SendCurrentStateAll();
		
		sprintf(lt,"player connected as admin: %s, localid=%u",client->playername,client->localid);
		Log(lt);
	}
	else
	if (msgtype==MSG_CONNECTASPLAYER)
	{
		client->admin=false;
		client->localid=((unsigned int*)p)[0];
		memcpy(client->playername,p+4,256);
		client->phase=1;

		UpdateEnemyMultiplier();

		SendCurrentStateAll();

		sprintf(lt,"player connected: %s, localid=%u, id=%u, clientptr=%llu",client->playername,client->localid,id,(unsigned long long)client);
		Log(lt);
	}
	else
	if (msgtype==MSG_CHATMSG)
	{
		// *** auch ein bug im windows server !!!       fixed in windowsserver
		*((unsigned int*)p)=client->id;
		// ***
		SendToAll(msgtype,p,len);
		sprintf(lt,"%s says: %s",client->playername,p+4);
		Log(lt);
	}
	else
	if (msgtype==MSG_READY)
	{
		if (client->ready) 
			client->ready=false;
		else
			client->ready=true;

		SendCurrentStateAll();

		if (client->ready)
			sprintf(lt,"%s: ready=true",client->playername);
		else
			sprintf(lt,"%s: ready=false",client->playername);
		Log(lt);
	}
	else
	if (msgtype==MSG_SETMAP)
	{
		memcpy(mapname,p,256);
		SendCurrentStateAll();

		sprintf(lt,"%s sets map to: %s",client->playername,mapname);
		Log(lt);
	}
	else
	if (msgtype==MSG_KICK)
	{
		unsigned int i,id;
		id=((unsigned int*)p)[0];
		if (id<csocketn)
		{
			sprintf(lt,"%s kicks %s",client->playername,csocket[id]->playername);
			Log(lt);

			close(csocket[id]->sock);
			delete csocket[id];
			for (i=id;i<csocketn-1;i++)
			{
				csocket[i]=csocket[i+1];
				csocket[i]->id=i;
			}
			csocketn--;
			csocket[csocketn]=new WServerClient();
			csocket[csocketn]->id=csocketn;
			csocket[csocketn]->ready=false;
	
			SendCurrentStateAll();		
		}
		else
		{
			// ***
			sprintf(lt,"%s kicks invalid player id %u; current num of players: %u",client->playername,id,csocketn);
			Log(lt);
			// ***
		}
	}
	else
	if (msgtype==MSG_SOUNDNOTIFY)
	{
		unsigned int id;
		id=((unsigned int*)p)[0];
		if (id<csocketn)
		{
			SendSave(id,MSG_SOUNDNOTIFY,0,0);

			sprintf(lt,"%s sounds %s",client->playername,csocket[id]->playername);
			Log(lt);
		}
		else
		{
			// ***
			sprintf(lt,"%s sounds invalid player id %u; current num of players: %u",client->playername,id,csocketn);
			Log(lt);
			// ***
		}
	}
	else
	if (msgtype==MSG_HARD)
	{
		hard=((unsigned int*)p)[0];

		SendCurrentStateAll();

		sprintf(lt,"%s sets multiplier to %u",client->playername,hard);
		Log(lt);
	}
	else
	if (msgtype==MSG_SETENEMYLIMIT)
	{
		unsigned int enemylimitold = enemylimit;
		enemylimit=((unsigned int*)p)[0];
		if (enemylimit > enemylimitlimit)
			enemylimit = enemylimitlimit;
		else
		if (enemylimit < 1)
			enemylimit = enemylimitold;

		SendCurrentStateAll();

		sprintf(lt,"%s sets enemy limit to %u",client->playername,enemylimit);
		Log(lt);
	}
	else
	if (msgtype==MSG_SETGAMEMODE)
	{
		mode=((unsigned int*)p)[0];

		SendCurrentStateAll();

		sprintf(lt,"%s sets game mode to %u",client->playername,mode);
		Log(lt);
	}
	else
	if (msgtype==MSG_STARTGAME2)
	{
		client->ready=false;

		sprintf(lt,"%s finished loading",client->playername);
		Log(lt);
	}
	else
	if (msgtype==MSG_INPUT)
	{
		if (phase==2)
			memcpy(inputstate+client->playid*4,p,8);
	}
	else
	if (msgtype==MSG_GAMEOVER)
	{
		phase=0;
		if (dedicated)
			SetRandomMap();

		sprintf(lt,"%s sent game over",client->playername);
		Log(lt);
	}
	else
	if (msgtype==MSG_GAMEOVERFORCE)
	{
		if (phase==2)
		{
			phase=0;
			SendToAll(MSG_GAMEOVERFORCE,0,0);
			if (dedicated)
				SetRandomMap();

			sprintf(lt,"%s aborted the game",client->playername);
			Log(lt);
		}
		else
		{
			sprintf(lt,"%s aborted the game. But I am in phase %u. Thus, I just ignore it.",client->playername,phase);
			Log(lt);
		}
	}
	else
	{
		//SendToAll(msgtype,p,len);
		//sprintf(lt,"%s sent unknown msgtype; forwarding to all other players",client->playername);

		sprintf(lt,"%s sent unknown msgtype; throwing it away",client->playername);
		Log(lt);
	}
}

unsigned int SendSave(unsigned int id, unsigned int msgtype, char *p, unsigned int len)
{
//	sprintf(lt,"sendsave, %u   %u   %u   %u",id,msgtype,(unsigned int)p,len);
//	Log(lt);
	char sendbuf[1024*MAXPLAYER+16];
	WServerClient *client=csocket[id];
//	sprintf(lt,"clientptr %u",(unsigned int)client);
//	Log(lt);
	((unsigned int*)sendbuf)[0]=len+4;
	((unsigned int*)sendbuf)[1]=msgtype;
	if (len!=0)
		memcpy(sendbuf+8,p,len);
//	sprintf(lt,"sendsave calls send: %u   %u   %u",client->sock,(unsigned int)client->sendbuf,len+8);
//	Log(lt);
	return send(client->sock,sendbuf,len+8,SENDFLAGS)-8;
}

void SendCurrentStateAll()
{
	updateonlinestatus=true;
	
	unsigned char buf[1024*MAXPLAYER];

	((unsigned int*)buf)[0]=csocketn;

	unsigned int i,ofs;
	ofs=4;
	for (i=0;i<csocketn;i++)
	{
		memcpy(buf+ofs,&csocket[i]->localid,4);
		ofs+=4;
		memcpy(buf+ofs,csocket[i]->playername,256);
		ofs+=256;
		memcpy(buf+ofs,&csocket[i]->ready,4);
		ofs+=4;
		memcpy(buf+ofs,&csocket[i]->admin,4);
		ofs+=4;
	}

	memcpy(buf+ofs,mapname,256);
	ofs+=256;
	memcpy(buf+ofs,&hard,4);
	ofs+=4;
	memcpy(buf+ofs,&mode,4);
	ofs+=4;
	memcpy(buf+ofs,&enemylimit,4);
	ofs+=4;

	SendToAll(MSG_CURRENTSTATE,(char*)buf,ofs);
}

void SendToAll(unsigned int msgtype, char *p, unsigned int len)
{
	unsigned int i;
	for (i=0;i<csocketn;i++)
	{
//		sprintf(lt,"sendtoall %u   %u   %u",i,(unsigned int)p,len);
//		Log(lt);
		SendSave(i,msgtype,p,len);
	}	
}

void SetRandomMap()
{
	if (randomize==false)
		return;

	FILE *f=fopen("maprand","rt");
	unsigned int num;
	fscanf(f,"%u",&num);
	unsigned int r=(num*(rand()>>16))/0x8000+1;
	unsigned int i,j;
	for (i=0;i<r;i++)
	{
		fscanf(f,"%s",mapname);
		for (j=0;j<strlen(mapname);j++)
			if (mapname[j]=='^')
			{
				mapname[j]=' ';
			}
	}
	fclose(f);

	sprintf(lt,"choosing map %u/%u: %s",r,num,mapname);
	Log(lt);

	UpdateEnemyMultiplier();

	SendCurrentStateAll();
}

void UpdateEnemyMultiplier()
{
	if (randomize==false)
		return;
		
	hard=(int)csocketn+(3*(rand()>>16))/0x8000;
	if (hard<1)
		hard=1;
	else
	if (hard>8)
		hard=8;
		
	sprintf(lt,"choosing multiplier %u",hard);
	Log(lt);
}


int main(int argc, char **argv)
{
	printf("This is wserver v%s.\n",version);
	sprintf(lt,"wserver v%s startup",version);
	Log(lt);
	
	Init();
	MainLoop();
}
